// Stromverlauf in einem Schwingkreis mit Dämpfung
#include "chart.h"
#include "matrix.h"

#define L 0.15
#define R 170.
#define C 1e-6
#define U 4.9
#define I 0.03

#define DELTA_T 1e-6
#define STEPS 10000

int main(void)
{
    double M[2][2] = { { 0., 1. }, { -1./(L*C), -R/L } };
    double y[2] = { -U*C, I };
    double dy_dt[2], t = 0;

    for(int i = 0; i < STEPS; ++i)
    {
        m_vmul(2, dy_dt, M, y);
        v_fadd(2, y, dy_dt, DELTA_T);
        t = t + DELTA_T;
        chart_lineto(1000 * t, 1000 * y[1], CHART_RED);
    }

    chart_axis_fmt("%g ms", "%g mA");
    chart_show(CHART_DEFAULT, "Schwingkreis");
    return 0;
}
